#!/usr/bin/php
<?php
$mainName = "main";
foreach($argv as $v) {
    if(false !== strpos($v, '=')) {
        $parts = explode('=', $v);
        ${$parts[0]} = $parts[1];
    }
}

function parseArgs($argv){
    array_shift($argv);
    $out = array();
    foreach ($argv as $arg){
        if (substr($arg,0,2) == '--'){
            $eqPos = strpos($arg,'=');
            if ($eqPos === false){
                $key = substr($arg,2);
                $out[$key] = isset($out[$key]) ? $out[$key] : true;
            } else {
                $key = substr($arg,2,$eqPos-2);
                $out[$key] = substr($arg,$eqPos+1);
            }
        } else if (substr($arg,0,1) == '-'){
            if (substr($arg,2,1) == '='){
                $key = substr($arg,1,1);
                $out[$key] = substr($arg,3);
            } else {
                $chars = str_split(substr($arg,1));
                foreach ($chars as $char){
                    $key = $char;
                    $out[$key] = isset($out[$key]) ? $out[$key] : true;
                }
            }
        } else {
            $out[] = $arg;
        }
    }
    return $out;
}
function makeWeekstatICS($myyear,$myweek,$mytitle,$mycontent){
	$weekstat_date = date_create();
	date_isodate_set($weekstat_date,$myyear,$myweek,7);
	$weekstat_date = $weekstat_date->format('U');
	return "BEGIN:VEVENT\n".
	"DTEND:".date('Ymd',(intval($weekstat_date,10)+86400))."\n".
	"SUMMARY:$mytitle\n".
	"DTSTART:".date('Ymd',$weekstat_date)."\n".
	"DESCRIPTION:$mycontent\n".
	"END:VEVENT\n";
}
function makeMonthstatICS($myyeart,$mymonth,$mytitle,$content){
	$monthstat_date = $myyeart."-".$mymonth."-01";
	$monthstat_date = strtotime(date("Y-m-t", strtotime($monthstat_date)));
	$monthstat_date = date("U",$monthstat_date);
	return "BEGIN:VEVENT\n".
	"DTEND:".date('Ymd',(intval($monthstat_date,10)+86400))."\n".
 	"SUMMARY:$mytitle\n".
	"DTSTART:".date('Ymd',$monthstat_date)."\n".
	"DESCRIPTION:$content\n".
	"END:VEVENT\n";
}
function return_day_event_dates($tz,$start,$stop){
	// Timzone, start-epoch int, stop-epoch int
	date_default_timezone_set($tz);
	$tz = new DateTimeZone($tz);
	$start = date('U',$start);
	$stop = date('U',$stop);
	$currentDayEnd = date('U',strtotime(date('Y-m-d',$start))+86399);


	$daydates = array();
	while (1==1) {	
		if ($currentDayEnd<$stop){
			// Erstelle Event mit start und CurrentDayEnd
			array_push($daydates,array(date('U',$start),date('U',$currentDayEnd)));
			// Setze Start auf das Ende des letzte Tages
			$start = $currentDayEnd+1;
			$currentDayEnd = $start + 86399;
		}else{
			array_push($daydates,array(date('U',$start),date('U',$stop)));
			break;
		}
	}
	return $daydates;
}

function duration($secs){ 
	$vals = array( 
		'd' => (int) ($secs / 86400), 
		'h' => $secs / 3600 % 24, 
		'm' => $secs / 60 % 60, 
		's' => $secs % 60
	); 
	$ret = array(); 
	$added = false; 
	foreach ($vals as $k => $v) { 
		if ($v > 0 || $added) { 
			$added = true; 
			$ret[] = $v . $k; 
		} 
	} 
	return join(' ', $ret); 
} 
function duration_h($secs){ 
	$vals = array( 
		'h' => (int)($secs / 3600), 
		'm' => $secs / 60 % 60, 
		's' => $secs % 60
	); 
	$ret = array(); 
	$added = false; 
	foreach ($vals as $k => $v) { 
		if ($v > 0 || $added) { 
			$added = true; 
			$ret[] = $v . $k; 
		} 
	} 
	return join(' ', $ret); 
} 

parseArgs($argv);
date_default_timezone_set($timezone);
#########################################################
#########################################################
if (!isset($sourcefile)){
	echo "ERROR: Sourcefile is not defined";
}else{
	if (!isset($timezone)){
		$timezone = "Europe/Berlin";
	}
	if (!isset($split)){
		$split = FALSE;
	}else if ($split=="TRUE"){
		$split = TRUE;
	}else{
		$split = FALSE;
	}
	date_default_timezone_set($timezone);
	$zeilen = file ($sourcefile);
	$project_names = array();
	for ($i=0; $i<count($zeilen);$i++){
		$zeile = preg_split("/\t/",$zeilen[$i]);
		$project = $zeile[0];
		array_push($project_names,$project);
		$name = $zeile[1];
		$start = date('U',strtotime(chop($zeile[2])));
		$stop = date('U',strtotime(chop($zeile[3])));
		if ($start != $stop){
			$event_starts_stops = return_day_event_dates($timezone,$start,$stop);
			foreach ($event_starts_stops as $key=>$startStop){
				$start=$startStop[0];
				$stop=$startStop[1];
				$duration = intval($stop,10)-intval($start,10);
				if (($key+1)<count($event_starts_stops)){
					// Wenn ein ZusatzEvent da über mehrere Tage + 1 Sekunde ;_) auf die Duration Ja wir sind kleinlich
					$duration++;
				}
				if (isset($Years[date('Y',$start)]['data'][date('m',$start)]['data'][date('W',$start)]['data'][$project])){
					array_push(
						$Years[date('Y',$start)]['data'][date('m',$start)]['data'][date('W',$start)]['data'][$project],
						join("\n",array(
							"BEGIN:VEVENT",
							"SUMMARY:".$project.":".$name,
							"DTSTART;TZID=".$timezone.':'.date('Ymd',$start).'T'.date('His',$start),
							"DTEND;TZID=".$timezone.':'.date('Ymd',$stop).'T'.date('His',$stop),
							"END:VEVENT"
							)
						)
					);
				}else{
					$Years[date('Y',$start)]['data'][date('m',$start)]['data'][date('W',$start)]['data'][$project]= array(
						join("\n",array(
							"BEGIN:VEVENT",
							"SUMMARY:".$project.":".$name,
							"DTSTART;TZID=".$timezone.':'.date('Ymd',$start).'T'.date('His',$start),
							"DTEND;TZID=".$timezone.':'.date('Ymd',$stop).'T'.date('His',$stop),
							"END:VEVENT"
							)
						)
					);
				}
				// Weekly-Stats
				if (isset($Years[date('Y',$start)]['data'][date('m',$start)]['data'][date('W',$start)]['weekstat'][$project][$name])){
					$Years[date('Y',$start)]['data'][date('m',$start)]['data'][date('W',$start)]['weekstat'][$project][$name]+=$duration;
				}else{
					$Years[date('Y',$start)]['data'][date('m',$start)]['data'][date('W',$start)]['weekstat'][$project][$name]=$duration;
				}
				// Monthly-Stats
				if (isset($Years[date('Y',$start)]['data'][date('m',$start)]['monthstat'][$project][$name])){
					$Years[date('Y',$start)]['data'][date('m',$start)]['monthstat'][$project][$name]+=$duration;
				}else{
					$Years[date('Y',$start)]['data'][date('m',$start)]['monthstat'][$project][$name]=$duration;
				}
				// Year-Stats
				if (isset($Years[date('Y',$start)]['yearstat'][$project][$name])){
					$Years[date('Y',$start)]['yearstat'][$project][$name]+=$duration;
				}else{
					$Years[date('Y',$start)]['yearstat'][$project][$name]=$duration;
				}
			}
		}else{
			if (isset($Years[date('Y',$start)]['data'][date('m',$start)]['data'][date('W',$start)]['data'][$project])){
				array_push(
					$Years[date('Y',$start)]['data'][date('m',$start)]['data'][date('W',$start)]['data'][$project],
					join("\n",array(
						"BEGIN:VEVENT",
						"SUMMARY:".$project.":".$name." (open)",
						"DTSTART;TZID=".$timezone.':'.date('Ymd',$start).'T'.date('His',$start),
						"DTEND;TZID=".$timezone.':'.date('Ymd',$stop).'T'.date('His',$stop),
						"END:VEVENT"
						)
					)
				);
			}else{
				$Years[date('Y',$start)]['data'][date('m',$start)]['data'][date('W',$start)]['data'][$project]= array(
					join("\n",array(
						"BEGIN:VEVENT",
						"SUMMARY:".$project.":".$name." (open)",
						"DTSTART;TZID=".$timezone.':'.date('Ymd',$start).'T'.date('His',$start),
						"DTEND;TZID=".$timezone.':'.date('Ymd',$stop).'T'.date('His',$stop),
						"END:VEVENT"
						)
					)
					);
				$Years[date('Y',$start)]['data'][date('m',$start)]['data'][date('W',$start)]['weekstat'] = array();
			}
		
		}
	}

	$HEADER="BEGIN:VCALENDAR\nMETHOD:PUBLISH\nVERSION:2.0\nX-WR-TIMEZONE:".$timezone."\nCALSCALE:GREGORIAN\nBEGIN:VTIMEZONE\nTZID:".$timezone."\nBEGIN:DAYLIGHT\nTZOFFSETFROM:+0100\nRRULE:FREQ=YEARLY;BYMONTH=3;BYDAY=-1SU\nDTSTART:19810329T020000\nTZNAME:GMT+02:00\nTZOFFSETTO:+0200\nEND:DAYLIGHT\nBEGIN:STANDARD\nTZOFFSETFROM:+0200\nRRULE:FREQ=YEARLY;BYMONTH=10;BYDAY=-1SU\nDTSTART:19961027T030000\nTZNAME:GMT+01:00\nTZOFFSETTO:+0100\nEND:STANDARD\nEND:VTIMEZONE\n";
	$FOOTER="\nEND:VCALENDAR";
	$myoutput['StatistikEvents'] = array();
	foreach ($Years as $Year => $Year_Data) {
		foreach ($Year_Data['data'] as $Month => $Month_Data) {
			
			foreach ($Month_Data['data'] as $Week => $Week_data) {
				// sammle ics-einträge
				foreach ($Week_data['data'] as $Project => $ICSDATA) {
				
					if (!isset($myoutput['ProjectEvents'][$Project])){
						$myoutput['ProjectEvents'][$Project] = array();
					}
					array_push($myoutput['ProjectEvents'][$Project], join("\n",$ICSDATA));
					array_push($myoutput['ProjectEvents'][$Project], "\n");
				}
				// WEEKLY STATS
				$week_stat_string = array();
				$grand_Total_week = 0;
				foreach($Week_data['weekstat'] as $Project => $Tasks){
					$ProjectWeek_Total = 0;
					
					array_push($week_stat_string, $Project.":");
					foreach($Tasks as $Task => $TaskDuration){
						$ProjectWeek_Total+=$TaskDuration;
						array_push($week_stat_string,$Task.': '.duration($TaskDuration));
					}
					$grand_Total_week+=$ProjectWeek_Total;
					array_push($week_stat_string,"-----------------");
					array_push($week_stat_string,"TOTAL: ".duration($ProjectWeek_Total)."\\n");
					$thisProjectWeekstatString = join("\\n",$week_stat_string);
					if ($split){
						// Sollte einzelen Dateien erstellt werden, diese Projekt-Statistik direkt Einfügen als einzelnen Termin
						array_push($myoutput['ProjectEvents'][$Project], makeWeekstatICS($Year,$Week,"Weekstats",$thisProjectWeekstatString));
						$week_stat_string = array();
					}else{
						//Ansonsten immer weiter sammeln und nach der Schleife in StatistikEvents einfügen
					}
				}

				
				if (!$split){
					array_push($myoutput['StatistikEvents'], makeWeekstatICS($Year,$Week,"Weekstats (∑ ".duration_h($grand_Total_week).")",$thisProjectWeekstatString));
				}
			}
			//MONTHLY STATS
			$grand_Total_month = 0;
			
			$month_stat_string = array();
			foreach($Month_Data['monthstat'] as $Monthstat => $Projectname){
				$ProjectMonth_Total = 0;
				array_push($month_stat_string, $Monthstat.":");
				foreach($Projectname as $Task => $TaskDuration){
					$ProjectMonth_Total+=$TaskDuration;
					array_push($month_stat_string,$Task.': '.duration($TaskDuration));
				}
				array_push($month_stat_string,"-----------------");
				array_push($month_stat_string,"TOTAL: ".duration($ProjectMonth_Total)."\\n");
				$thisProjectMonthstatString = join("\\n",$month_stat_string);
				$grand_Total_month+=$ProjectMonth_Total;
				if ($split){
					// Sollte einzelen Dateien erstellt werden, diese Projekt-Statistik direkt Einfügen als einzelnen Termin
					array_push($myoutput['ProjectEvents'][$Monthstat], makeMonthstatICS($Year,$Month,"Monthstats",$thisProjectMonthstatString));
					$month_stat_string = array();
				}else{
					//Ansonsten immer weiter sammeln und nach der Schleife in StatistikEvents einfügen
				}
			}
			if (!$split){
				array_push($myoutput['StatistikEvents'], makeMonthstatICS($Year,$Month,"Monthstats(∑ ".duration_h($grand_Total_month).")",$thisProjectMonthstatString));
			}
		}
	}
	// DATEIAUSGABE
	if ($split){
		foreach($myoutput['ProjectEvents'] as $eventname => $data){
			//remove unwanted characters from filename
			$eventname = preg_replace("/[^a-zA-Z]+/", "", $eventname);
			file_put_contents($output.$eventname.".ics",$HEADER);
			file_put_contents($output.$eventname.".ics",join("\n",$data),FILE_APPEND);
			file_put_contents($output.$eventname.".ics",$FOOTER,FILE_APPEND);
		}
	}else{
		file_put_contents($output.$mainName.".ics",$HEADER);
		foreach($myoutput['ProjectEvents'] as $eventname => $data){
			file_put_contents($output.$mainName.".ics",join("\n",$data),FILE_APPEND);
		}
		file_put_contents($output.$mainName.".ics",join("\n",$myoutput['StatistikEvents']),FILE_APPEND);
		file_put_contents($output.$mainName.".ics",$FOOTER,FILE_APPEND);
	}
}

?>